=== modified file 'procurement_request/procurement_request_view.xml'
--- procurement_request/procurement_request_view.xml	2011-11-21 10:01:18 +0000
+++ procurement_request/procurement_request_view.xml	2011-12-27 15:55:06 +0000
@@ -54,8 +54,7 @@
                                     <field name="latest" />
 				    <field name="my_company_id" invisible="1" />
                                     <field name="supplier" context="{'product_id': product_id, 'choose_supplier': True}" attrs="{'readonly': [('type', '=', 'make_to_stock')]}" domain="[('supplier', '=', True), ('id', '!=', my_company_id)]"/>
-                                    <!-- <button name="split_line" type="object" string="Split Line" icon="terp-stock_effects-object-colorize" />
-                                    <button name="merge_line" type="object" string="Merge Line" icon="terp-gtk-jump-to-ltr" context="{'wizard_id': active_id}" /> -->
+                                    <button name="open_split_wizard" type="object" string="Split Line" icon="terp-stock_effects-object-colorize" />
                                 </tree>
                                 <form>
                                    <field name="product_id" colspan="4" />

=== modified file 'purchase_override/__init__.py'
--- purchase_override/__init__.py	2011-11-15 15:41:33 +0000
+++ purchase_override/__init__.py	2011-12-27 15:55:06 +0000
@@ -9,3 +9,4 @@
 
 import purchase
 import report
+import wizard

=== modified file 'purchase_override/__openerp__.py'
--- purchase_override/__openerp__.py	2011-09-30 16:28:56 +0000
+++ purchase_override/__openerp__.py	2011-12-27 15:55:06 +0000
@@ -38,6 +38,7 @@
     "update_xml": [
         "purchase_view.xml",
         "purchase_workflow.xml",
+        "wizard/split_order_line_view.xml",
         "report/purchase_report_view.xml",
     ],
     "demo_xml": [

=== modified file 'purchase_override/purchase.py'
--- purchase_override/purchase.py	2011-12-14 17:14:59 +0000
+++ purchase_override/purchase.py	2011-12-27 15:55:06 +0000
@@ -363,6 +363,41 @@
     
 purchase_order()
 
+
+class purchase_order_line(osv.osv):
+    _name = 'purchase.order.line'
+    _inherit = 'purchase.order.line'
+
+
+    _columns = {
+        'parent_line_id': fields.many2one('purchase.order.line', string='Parent line'),
+    }
+
+    def open_split_wizard(self, cr, uid, ids, context={}):
+        '''
+        Open the wizard to split the line
+        '''
+        if not context:
+            context = {}
+ 
+        if isinstance(ids, (int, long)):
+            ids = [ids]
+
+        for line in self.browse(cr, uid, ids, context=context):
+            data = {'purchase_line_id': line.id, 'original_qty': line.product_qty, 'old_line_qty': line.product_qty}
+            wiz_id = self.pool.get('split.purchase.order.line.wizard').create(cr, uid, data, context=context)
+            return {'type': 'ir.actions.act_window',
+                    'res_model': 'split.purchase.order.line.wizard',
+                    'view_type': 'form',
+                    'view_mode': 'form',
+                    'target': 'new',
+                    'res_id': wiz_id,
+                    'context': context}
+
+
+purchase_order_line()
+
+
 class account_invoice(osv.osv):
     _name = 'account.invoice'
     _inherit = 'account.invoice'

=== modified file 'purchase_override/purchase_view.xml'
--- purchase_override/purchase_view.xml	2011-12-14 17:14:59 +0000
+++ purchase_override/purchase_view.xml	2011-12-27 15:55:06 +0000
@@ -24,6 +24,10 @@
                     <xpath expr="/form/notebook/page[@string='Delivery &amp; Invoicing']//field[@name='invoice_method']" position="replace">
                         <field name="invoice_method" attrs="{'readonly':[('state','in', ['confirmed','approved','done'] )] , 'invisible': [('order_type', 'in', ['donation_exp', 'donation_st', 'in_kind', 'loan'])]}" />
                     </xpath>
+
+                    <xpath expr="/form/notebook//tree//field[@name='price_subtotal']" position="after">
+                        <button string="Split line" icon="terp-stock_effects-object-colorize" name="open_split_wizard" type="object" />
+                    </xpath>
                 </data>
             </field>
         </record>

=== added directory 'purchase_override/wizard'
=== added file 'purchase_override/wizard/__init__.py'
--- purchase_override/wizard/__init__.py	1970-01-01 00:00:00 +0000
+++ purchase_override/wizard/__init__.py	2011-12-27 15:55:06 +0000
@@ -0,0 +1,1 @@
+import split_order_line

=== added file 'purchase_override/wizard/split_order_line.py'
--- purchase_override/wizard/split_order_line.py	1970-01-01 00:00:00 +0000
+++ purchase_override/wizard/split_order_line.py	2011-12-27 15:55:06 +0000
@@ -0,0 +1,81 @@
+# -*- coding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2011 TeMPO Consulting, MSF 
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+
+from osv import osv, fields
+
+from tools.translate import _
+
+
+class split_purchase_order_line_wizard(osv.osv_memory):
+    _name = 'split.purchase.order.line.wizard'
+    _description = 'Split purchase order lines'
+
+    _columns = {
+        'purchase_line_id': fields.many2one('purchase.order.line', string='Line Id', readonly=True),
+        'original_qty': fields.float(digits=(16,2), string='Original Quantity', readonly=True),
+        'old_line_qty': fields.float(digits=(16,2), string='Old line quantity', readonly=True),
+        'new_line_qty': fields.float(digits=(16,2), string='New line quantity', required=True),
+    }
+
+    _defaults = {
+        'new_line_qty': lambda *a: 0.00,
+    }
+
+    def split_line(self, cr, uid, ids, context={}):
+        '''
+        Create a new order line and change the quantity of the old line
+        '''
+        line_obj = self.pool.get('purchase.order.line')
+
+        if not context:
+            context = {}
+
+        if isinstance(ids, (int, long)):
+            ids = [ids]
+
+        for split in self.browse(cr, uid, ids, context=context):
+            # Check if the sum of new line and old line qty is equal to the original qty
+            if split.old_line_qty  > split.original_qty:
+                raise osv.except_osv(_('Error'), _('You cannot have a new quantity different than the original quantity !'))
+            # Change the qty of the old line
+            line_obj.write(cr, uid, [split.purchase_line_id.id], {'product_qty': split.original_qty - split.new_line_qty}, context=context)
+            # Create the new line
+            new_line_id = line_obj.copy(cr, uid, split.purchase_line_id.id, {'parent_line_id': split.purchase_line_id.id,
+                                                                         'product_qty': split.new_line_qty}, context=context)
+
+        return {'type': 'ir.actions.act_window_close'}
+
+    def line_qty_change(self, cr, uid, ids, original_qty, new_line_qty, context={}):
+        '''
+        Update the old line qty according to the new line qty
+        '''
+        if new_line_qty > original_qty:
+            raise osv.except_osv(_('Error'), _('You cannot have a new line quantity bigger than the original quantity'))
+        elif new_line_qty == original_qty:
+            raise osv.except_osv(_('Error'), _('You cannot have a new line quantity equal to the original quantity'))
+
+        res = {'old_line_qty': original_qty - new_line_qty}
+
+        return {'value': res}
+
+split_purchase_order_line_wizard()
+
+# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

=== added file 'purchase_override/wizard/split_order_line_view.xml'
--- purchase_override/wizard/split_order_line_view.xml	1970-01-01 00:00:00 +0000
+++ purchase_override/wizard/split_order_line_view.xml	2011-12-27 15:55:06 +0000
@@ -0,0 +1,25 @@
+<?xml version="1.0" encoding="utf-8" ?>
+<openerp>
+    <data>
+
+        <record id="split_purchase_order_line_view" model="ir.ui.view">
+            <field name="name">split.purchase.order.line.view</field>
+            <field name="model">split.purchase.order.line.wizard</field>
+            <field name="type">form</field>
+            <field name="arch" type="xml">
+                <form string="Split line">
+                    <separator colspan="4" string="Quantities" />
+                    <field name="original_qty" />
+                    <field name="old_line_qty" />
+                    <field name="new_line_qty" on_change="line_qty_change(original_qty, new_line_qty)" />
+                    <separator colspan="4" string="Actions" />
+                    <group>
+                        <button special="cancel" string="Cancel" icon="gtk-cancel" />
+                        <button name="split_line" string="Split line" icon="terp-stock_effects-object-colorize" colspan="3" type="object" />
+                    </group>
+                </form>
+            </field>
+        </record>
+
+    </data>
+</openerp>

=== modified file 'sale_override/__init__.py'
--- sale_override/__init__.py	2011-11-15 15:41:33 +0000
+++ sale_override/__init__.py	2011-12-27 15:55:06 +0000
@@ -9,3 +9,4 @@
 
 import sale
 import report
+import wizard

=== modified file 'sale_override/__openerp__.py'
--- sale_override/__openerp__.py	2011-09-30 16:28:56 +0000
+++ sale_override/__openerp__.py	2011-12-27 15:55:06 +0000
@@ -36,6 +36,7 @@
     "update_xml": [
         "sale_view.xml",
         "sale_workflow.xml",
+        "wizard/split_order_line_view.xml",
         "report/sale_report_view.xml",
     ],
     "demo_xml": [

=== modified file 'sale_override/sale.py'
--- sale_override/sale.py	2011-12-14 17:14:59 +0000
+++ sale_override/sale.py	2011-12-27 15:55:06 +0000
@@ -364,4 +364,36 @@
 
 sale_order()
 
+
+class sale_order_line(osv.osv):
+    _name = 'sale.order.line'
+    _inherit = 'sale.order.line'
+
+    _columns = {
+        'parent_line_id': fields.many2one('sale.order.line', string='Parent line'),
+    }
+
+    def open_split_wizard(self, cr, uid, ids, context={}):
+        '''
+        Open the wizard to split the line
+        '''
+        if not context:
+            context = {}
+
+        if isinstance(ids, (int, long)):
+            ids = [ids]
+
+        for line in self.browse(cr, uid, ids, context=context):
+            data = {'sale_line_id': line.id, 'original_qty': line.product_uom_qty, 'old_line_qty': line.product_uom_qty}
+            wiz_id = self.pool.get('split.sale.order.line.wizard').create(cr, uid, data, context=context)
+            return {'type': 'ir.actions.act_window',
+                    'res_model': 'split.sale.order.line.wizard',
+                    'view_type': 'form',
+                    'view_mode': 'form',
+                    'target': 'new',
+                    'res_id': wiz_id,
+                    'context': context}
+
+sale_order_line()
+
 # vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

=== modified file 'sale_override/sale_view.xml'
--- sale_override/sale_view.xml	2011-12-14 17:14:59 +0000
+++ sale_override/sale_view.xml	2011-12-27 15:55:06 +0000
@@ -43,6 +43,9 @@
                     <!-- <xpath expr="/form/notebook/page[@string='Other Information']/group/field[@name='order_policy']" position="replace">
                         <field name="order_policy" on_change="shipping_policy_change(order_policy, order_type, partner_id, 'order_policy')"/>
                     </xpath> -->
+                    <xpath expr="/form/notebook//tree/field[@name='price_subtotal']" position="after">
+                        <button string="Split line" icon="terp-stock_effects-object-colorize" name="open_split_wizard" type="object" />
+                    </xpath>
                 </data>
             </field>
         </record>

=== added directory 'sale_override/wizard'
=== added file 'sale_override/wizard/__init__.py'
--- sale_override/wizard/__init__.py	1970-01-01 00:00:00 +0000
+++ sale_override/wizard/__init__.py	2011-12-27 15:55:06 +0000
@@ -0,0 +1,1 @@
+import split_order_line

=== added file 'sale_override/wizard/split_order_line.py'
--- sale_override/wizard/split_order_line.py	1970-01-01 00:00:00 +0000
+++ sale_override/wizard/split_order_line.py	2011-12-27 15:55:06 +0000
@@ -0,0 +1,81 @@
+# -*- coding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2011 TeMPO Consulting, MSF 
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+
+from osv import osv, fields
+
+from tools.translate import _
+
+
+class split_sale_order_line_wizard(osv.osv_memory):
+    _name = 'split.sale.order.line.wizard'
+    _description = 'Split sale order lines'
+
+    _columns = {
+        'sale_line_id': fields.many2one('sale.order.line', string='Line Id', readonly=True),
+        'original_qty': fields.float(digits=(16,2), string='Original Quantity', readonly=True),
+        'old_line_qty': fields.float(digits=(16,2), string='Old line quantity', readonly=True),
+        'new_line_qty': fields.float(digits=(16,2), string='New line quantity', required=True),
+    }
+
+    _defaults = {
+        'new_line_qty': lambda *a: 0.00,
+    }
+
+    def split_line(self, cr, uid, ids, context={}):
+        '''
+        Create a new order line and change the quantity of the old line
+        '''
+        line_obj = self.pool.get('sale.order.line')
+
+        if not context:
+            context = {}
+
+        if isinstance(ids, (int, long)):
+            ids = [ids]
+
+        for split in self.browse(cr, uid, ids, context=context):
+            # Check if the sum of new line and old line qty is equal to the original qty
+            if split.old_line_qty  > split.original_qty:
+                raise osv.except_osv(_('Error'), _('You cannot have a new quantity different than the original quantity !'))
+            # Change the qty of the old line
+            line_obj.write(cr, uid, [split.sale_line_id.id], {'product_uom_qty': split.original_qty - split.new_line_qty}, context=context)
+            # Create the new line
+            new_line_id = line_obj.copy(cr, uid, split.sale_line_id.id, {'parent_line_id': split.sale_line_id.id,
+                                                                         'product_uom_qty': split.new_line_qty}, context=context)
+
+        return {'type': 'ir.actions.act_window_close'}
+
+    def line_qty_change(self, cr, uid, ids, original_qty, new_line_qty, context={}):
+        '''
+        Update the old line qty according to the new line qty
+        '''
+        if new_line_qty > original_qty:
+            raise osv.except_osv(_('Error'), _('You cannot have a new line quantity bigger than the original quantity'))
+        elif new_line_qty == original_qty:
+            raise osv.except_osv(_('Error'), _('You cannot have a new line quantity equal to the original quantity'))
+
+        res = {'old_line_qty': original_qty - new_line_qty}
+
+        return {'value': res}
+
+split_sale_order_line_wizard()
+
+# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

=== added file 'sale_override/wizard/split_order_line_view.xml'
--- sale_override/wizard/split_order_line_view.xml	1970-01-01 00:00:00 +0000
+++ sale_override/wizard/split_order_line_view.xml	2011-12-27 15:55:06 +0000
@@ -0,0 +1,25 @@
+<?xml version="1.0" encoding="utf-8" ?>
+<openerp>
+    <data>
+
+        <record id="split_sale_order_line_view" model="ir.ui.view">
+            <field name="name">split.sale.order.line.view</field>
+            <field name="model">split.sale.order.line.wizard</field>
+            <field name="type">form</field>
+            <field name="arch" type="xml">
+                <form string="Split line">
+                    <separator colspan="4" string="Quantities" />
+                    <field name="original_qty" />
+                    <field name="old_line_qty" />
+                    <field name="new_line_qty" on_change="line_qty_change(original_qty, new_line_qty)" />
+                    <separator colspan="4" string="Actions" />
+                    <group>
+                        <button special="cancel" string="Cancel" icon="gtk-cancel" />
+                        <button name="split_line" string="Split line" icon="terp-stock_effects-object-colorize" colspan="3" type="object" />
+                    </group>
+                </form>
+            </field>
+        </record>
+
+    </data>
+</openerp>

